//+------------------------------------------------------------------+
//|                                                    PR_system.mq4 |
//|                                Copyright  2008, Sergey Lukyanov |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#include <stdlib.mqh>
#property copyright "Lukyanov S.V. ICQ: 50091010"

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+


extern string  OptEA             = "-=   =- ";
extern int     stopLoss       = 100;
extern double  ManLot            = 0.01;    //    
extern int     Slippage       = 3;
extern int     Magic          = 777;

extern string  OptSAR             = "-=  SAR =- ";
extern double step = 0.005;
extern double maximum = 0.1;
extern int shift_sar = 1;

extern string  OptRSI             = "-=  RSI =- ";
extern int PeriodRSI = 14;
extern int applied_price = 0;
extern int shift_rsi = 1;

//  
extern string  OptMM             = "-=  Money management =- ";
extern bool    MM                = false;   // Money management
extern int     BalanceUse        = 100;
extern int     Risk              = 100;     // Percent(%). minimum '1' maximum '100' 

//   
extern string  OptTS             = "-=    =- ";
extern bool UseTrailing      = False;        //  
extern bool ProfitTrailing   = True;        //   
extern int  TrailingStop     = 40;          //  
extern int  TrailingStep     = 10;          //  
extern int  NumberOfTry      = 7;  //     
extern int  PauseAfterError  = 2; //      

//      
extern string  OptSound       = "-=   =- ";
extern bool   UseSound        = False; 
extern string NameFileSound   = "expert.wav"; //   

color   clModifyBuy = Aqua;    //    
color   clModifySell = Tomato; //    

color   clOpenBuy      = Blue;
color   clCloseBuy     = Aqua;
color   clOpenSell     = Red;
color   clCloseSell    = Violet;
string  Name_Expert    = "PR_system";

int n=0, LotsDigit=1, probit_sell = 0, probit_buy = 0;

int init()
{
   return(0);
}

int deinit(){return(0);}

int start()
{

/*
1.    (   ) Parabolic Sar -
1.1.      ,           
1.2.      ,           .
( ()  0,005,  0,1).
2.       :
2.1       Relative Strenght Index( RSI):
-    :
2.1.1  () 70  RSI  ;   -
2.1.2.  (   )  65,  RSI  .
2.2.       Relative Strenght Index:
-    :
2.2.1.  () 30  RSI  ;   -
2.2.2.  (   )  35,  RSI  .
3.  Parabolic Sar -  Parabolic Sar  :
3.1.     ,  parabolica (     - ..   )  
     (      1.1.)
3.2.    ,  parabolica (     - ..   )  
     (      1.2.)
*/

  double parabolic = iSAR(Symbol(),0, step, maximum, shift_sar);
  double rsi = iRSI(Symbol(), 0, PeriodRSI, applied_price, shift_rsi);
    
  double parabolic_p = iSAR(Symbol(),0, step, maximum, shift_sar+1);
  double rsi_p = iRSI(Symbol(), 0, PeriodRSI, applied_price, shift_rsi+1);
  
  if (ExistPositions())
   {
      if(OrderType()==OP_BUY)
      
      {
        if (rsi > 70 ) probit_sell = 1;
        if (rsi <= 65 && probit_sell == 1) { CloseBuy(); probit_sell = 0; }
        
        if (Bid < parabolic && Bid > parabolic_p)
         {
           CloseBuy(); 
         }        
 
      }
      
      if(OrderType()==OP_SELL)
      {
        if (rsi < 30 ) probit_buy = 1;
        if (rsi >= 35 && probit_buy == 1) { CloseSell(); probit_buy = 0; }
        
         if (Ask > parabolic && Ask < parabolic_p)
          { 
            CloseSell(); 
          }
        
      }
      
    }

   if(!ExistPositions())  
   {   
      if (Ask > parabolic && Ask < parabolic_p)
       { 
         OpenBuy(); 
       }
      if (Bid < parabolic && Bid > parabolic_p)
       {
         OpenSell(); 
       }
   }

   
 if (UseTrailing) TrailingPositions();

 return (0); 
}//end start

// - - - - - -  - - - - - - -

//----    
bool ExistPositions() {
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol()) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) return(True);
      }
    }
  }
  return(False);
}

void CloseBuy() { 
   bool fc; 
   fc=OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy); 
   if (fc && UseSound) PlaySound(NameFileSound); 
} 

void CloseSell() { 
   bool fc; 
   fc=OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell); 
   if (fc && UseSound) PlaySound(NameFileSound); 
} 

//---- 
void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot();
   RefreshRates();
   ldStop = NormalizeDouble(Bid-Point*stopLoss, Digits); 
   lsComm = "1.0"; 
   OrderSend(Symbol(),OP_BUY,ldLot,NormalizeDouble(Ask,Digits),Slippage,ldStop,0,lsComm,Magic,0,clOpenBuy); 

   n=iBars(NULL,0);
   if (UseSound) PlaySound(NameFileSound);   }

//----  
void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   RefreshRates();
   ldStop = NormalizeDouble(Ask+Point*stopLoss, Digits); 
   lsComm = "1.0"; 
   OrderSend(Symbol(),OP_SELL,ldLot,NormalizeDouble(Bid,Digits),Slippage,ldStop,0,lsComm,Magic,0,clOpenSell); 
  /* Alert(GetLastError());
   Alert("SELL: ",Bid," STOP: ",ldStop, " TAKE: ",ldTake);*/
   n=iBars(NULL,0);
   if (UseSound) PlaySound(NameFileSound);   }
 
//   
double _AccountFreeMargin(){
   double _AccountBalance = AccountBalance() - (AccountBalance() * BalanceUse * 0.01);
   return (AccountFreeMargin()- _AccountBalance);
}   

//  
double GetSizeLot() { 
   double Lots,MD,RM,FMM,MinLot,MaxLot; 
   int lotsdigit; 
   MD = NormalizeDouble(MarketInfo(Symbol(), MODE_LOTSTEP),2); 
   RM = NormalizeDouble(MarketInfo(Symbol(), MODE_MARGINREQUIRED),4); 
   FMM = (RM)*100; 
      if (MD==0.01){
         lotsdigit=2;
      }
      else{
         lotsdigit=1;
      }
   LotsDigit=lotsdigit; 
      if (MM==true){
         Lots = NormalizeDouble(_AccountFreeMargin()/(FMM/Risk)-0.05,LotsDigit);
      }
      else{
         Lots=ManLot;
      }
   MinLot=NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT),2); 
   MaxLot=NormalizeDouble(MarketInfo(Symbol(), MODE_MAXLOT),2); 
      if (LotsDigit == 2){
         MinLot = 0.01;
      } 
      if (Lots < MinLot){
         Lots = MinLot; 
      }
      if (Lots > MaxLot){
         Lots = MaxLot;
      }
return(Lots); 
} 

//+----------------------------------------------------------------------------+
//|                                           |
//|  :                                                                |
//|    sym -    ("" -  )                   |
//|    op  -                   (-1 -  )                    |
//|    mn  - MagicNumber               (-1 -  )                      |
//+----------------------------------------------------------------------------+
void TrailingPositions(string sym = "", int op = -1, int mn = -1) 
  {
   double p, pp;
   int    i, k = OrdersTotal();
//----
   if(sym == "") 
       sym = Symbol();
   p = Point;
   for(i = 0; i < k; i++) 
     {
       if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
         {
           if(OrderSymbol() == sym && (op < 0 || OrderType() == op)) 
             {
               if(mn < 0 || OrderMagicNumber() == mn) 
                 {
                   if(OrderType() == OP_BUY) 
                     {
                       pp = MarketInfo(sym, MODE_BID);
                       if(!ProfitTrailing || (pp - OrderOpenPrice()) > TrailingStop*p) 
                         {
                           if(OrderStopLoss() < pp - (TrailingStop + TrailingStep - 1)*p) 
                             {
                               ModifyOrder(-1, pp - TrailingStop*p, 0, clModifyBuy);
                             }
                         }
                     }
                   if(OrderType() == OP_SELL) 
                     {
                       pp = MarketInfo(sym, MODE_ASK);
                       if(!ProfitTrailing || OrderOpenPrice() - pp > TrailingStop*p) 
                         {
                           if(OrderStopLoss() > pp + (TrailingStop + 
                              TrailingStep - 1)*p || OrderStopLoss() == 0) 
                             {
                               ModifyOrder(-1, pp + TrailingStop*p, 0, clModifySell);
                             }
                         }
                     }
                 }
             }
         }
     }
  }
//+----------------------------------------------------------------------------+
//|                                                           |
//|  :                                                                |
//|    pp -                                                                |
//|    sl -                                                                |
//|    tp -                                                                |
//|    cl -                                                                |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp = -1, double sl = 0, double tp = 0, color cl = CLR_NONE) 
  {
   bool fm;
   int  err, it;
//----
   if(pp <= 0) 
       pp = OrderOpenPrice();
   if(sl < 0) 
       sl = OrderStopLoss();
   if(tp < 0) 
       tp = OrderTakeProfit();
//---- 
   pp = NormalizeDouble(pp, Digits);
   sl = NormalizeDouble(sl, Digits);
   tp = NormalizeDouble(tp, Digits);
//----
   if(pp != OrderOpenPrice() || sl != OrderStopLoss() || tp != OrderTakeProfit()) 
     {
       for(it = 1; it <= NumberOfTry; it++) 
         {
           while(!IsTradeAllowed()) 
               Sleep(5000);
           RefreshRates();
           fm = OrderModify(OrderTicket(), pp, sl, tp, 0, cl);
           if(fm) 
             {
               if(UseSound) 
                   PlaySound(NameFileSound); 
               break;
             } 
           else 
             {
               err = GetLastError();
               Print("(", err, ")   : ", ErrorDescription(err),", try ", it);
               Print("Ask=", Ask, " | Bid=", Bid," | =", pp, " | =", sl, " | =", tp);
               Sleep(1000*PauseAfterError);
             }
         }
     }
  }


